/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include "GC.h"
#include "ActionFO.h"
#include "ActionHoming.h"
#include "Face.h"
#include "List.h"
#include "Scene/CollisionGroup.h"
#include "Scene/SceneMediator.h"

bool ActionHoming::action(SceneMediator* mediator, ActionFO* fo)
{
    if ( frameCount-- <= 0 ) {
        frameCount = frameCount_bak;
        return true;
    }

    CollisionListener* targetObj = mediator->getObject(target, index);
    if ( targetObj == NULL ) { return false; }

    double lx = (targetObj->x + targetObj->width/2) - (fo->x + fo->width / 2);
    double ly = (targetObj->y + targetObj->height/2) - (fo->y + fo->height / 2);
    double length = sqrt( lx*lx + ly*ly );

    fo->dx += coefficientHomingX * speed * lx / length + dx;
    fo->dy += coefficientHomingY * speed * ly / length + dy;

    return false;
}

ActionHoming* ActionHoming::create(CollisionGroup::group target, int index, double speed, int frameCount, double dx, double dy, double chx, double chy)
{
    ActionHoming* obj = GC<ActionHoming>::getInstance();
    obj->frameCount = frameCount;
    obj->frameCount_bak = frameCount;
    obj->target = target;
    obj->speed = speed;
    obj->index = index;
    obj->dx = dx;
    obj->dy = dy;
    obj->coefficientHomingX = chx;
    obj->coefficientHomingY = chy;
    return obj;
}

void ActionHoming::destroy()
{
    GC<ActionHoming>::destroy(this);
}

ActionHoming*  ActionHoming::clone()
{
    return create(target, index, speed, frameCount, dx, dy, coefficientHomingX, coefficientHomingY);
}
