/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include "GC.h"
#include "ActionFO.h"
#include "ActionMoveTarget.h"
#include "Face.h"
#include "Scene/SceneMediator.h"

bool ActionMoveTarget::action(SceneMediator* mediator, ActionFO* fo)
{
    frameCount--;
    double lx = x - (fo->x + fo->width / 2);
    double ly = y - (fo->y + fo->height / 2);
    double length = sqrt( lx*lx + ly*ly );

    if ( length > speed ) {
        fo->dx += speed * lx / length;
        fo->dy += speed * ly / length;
    }

    if ( frameCount <= 0 ) {
        frameCount = frameCount_bak;
        return true;
    }
    return false;
}

ActionMoveTarget* ActionMoveTarget::create(double x, double y, double speed, int frameCount)
{
    ActionMoveTarget* obj = GC<ActionMoveTarget>::getInstance();
    obj->x = x;
    obj->y = y;
    obj->frameCount = frameCount;
    obj->frameCount_bak = frameCount;
    obj->speed = speed;
    return obj;
}

void ActionMoveTarget::destroy()
{
    GC<ActionMoveTarget>::destroy(this);
}

ActionMoveTarget*  ActionMoveTarget::clone()
{
    return create(x, y, speed, frameCount);
}
