/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include "Border.h"
#include "GC.h"
#include "Scene/SceneMediator.h"

Border::Border()
{
}

bool Border::collision(SceneMediator* mediator, CollisionListener* listener)
{
    return true;
}

void Border::damaged(SceneMediator* mediator, CollisionListener* listener, int damage)
{
}

void Border::powered(SceneMediator* mediator, CollisionListener* listener, int amount)
{
}

void Border::destroy()
{
    GC<Border>::destroy(this);
}

void Border::destroy(SceneMediator* mediator)
{
    mediator->removeCollision(this);
    mediator->removeAction(this);
    destroy();
}

bool Border::action(SceneMediator* mediator)
{
    frameCount--;
    if ( frameCount <= 0 ) {
        mediator->removeCollision(this);
        return false;
    }
    else { return true; }
}

Border* Border::create(double x, double y, int width, int height, int frameCount, CollisionGroup::group group, double impactResilience)
{
    Border* border = GC<Border>::getInstance();
    border->x = x;
    border->y = y;
    border->width = width;
    border->height = height;
    border->frameCount = frameCount;
    border->setGroup(group);
    border->impactResilience = impactResilience;
    return border;
}

void Border::init(SceneMediator* mediator)
{
    mediator->addAction(this);
    mediator->addCollision(this);
}

Border* Border::clone()
{
    return create(x, y, width, height, frameCount, getGroup(), impactResilience);
}
