/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>

#include <SDL/SDL_mixer.h>

#include "Event_Music.h"
#include "Sound.h"

using namespace std;

const int Event_Music::START = 0;
const string Event_Music::START_STR = "通常";
const int Event_Music::FADEIN = 1;
const string Event_Music::FADEIN_STR = "フェードイン";
const int Event_Music::UNPAUSE = 2;
const string Event_Music::UNPAUSE_STR = "再開";

Event_Music::Event_Music(string filename, int loop, int startType, int time, int frameCount)
{
    this->filename = filename;
    this->loop = loop;
    this->frameCount = frameCount;
    this->startType = startType;
    this->time = time;
    if ( !filename.empty() ) { Sound::getInstance()->loadMusic(filename); }
}

Event_Music::Event_Music(string filename, int loop, int startType, int time )
{
    this->filename = filename;
    this->loop = loop;
    if ( !filename.empty() ) { Sound::getInstance()->loadMusic(filename); }
    this->startType = startType;
    this->time = time;
}

void Event_Music::doEvent(SceneMediator* mediator)
{
    switch( startType ) {
        case START: Sound::playMusic(filename, loop); break;
        case FADEIN: Sound::playFadeinMusic(filename, loop, time); break;
        case UNPAUSE: Mix_ResumeMusic(); break;
        default:
        {
            cerr << "Event_Music("<<startType<<"):";
            cerr << "無効な開始タイプです。" << endl;
            exit(-1);
        }
    }
}
