/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <string>
#include <iostream>

#include <SDL/SDL_mixer.h>

#include "Event_MusicStop.h"
#include "Sound.h"

using namespace std;
const int Event_MusicStop::STOP = 0;
const string Event_MusicStop::STOP_STR = "停止";
const int Event_MusicStop::PAUSE = 1;
const string Event_MusicStop::PAUSE_STR = "ポーズ";
const int Event_MusicStop::FADEOUT = 2;
const string Event_MusicStop::FADEOUT_STR = "フェードアウト";

Event_MusicStop::Event_MusicStop(int stopType, int time, int frameCount)
{
    this->stopType = stopType;
    this->time = time;
    this->frameCount = frameCount;
}

Event_MusicStop::Event_MusicStop(int stopType, int time)
{
    this->stopType = stopType;
    this->time = time;
}

void Event_MusicStop::doEvent(SceneMediator* mediator)
{
    switch( stopType ) {
        case STOP: Mix_HaltMusic(); break;
        case PAUSE: Mix_PauseMusic(); break;
        case FADEOUT: Mix_FadeOutMusic(time); break;
        default:
        {
            cerr << "Event_MusicStop("<<stopType<<"):";
            cerr << "無効な停止タイプです。" << endl;
            exit(-1);
        }
    }
}
