/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>

#include <SDL/SDL_mixer.h>

#include "Event_Scene.h"
#include "Scene.h"
#include "Scene/SceneMediator.h"

using namespace std;

const int Event_Scene::END = 0;
const string Event_Scene::END_STR = "終了";
const int Event_Scene::GOTO = 1;
const string Event_Scene::GOTO_STR = "移動";
const int Event_Scene::GOSUB = 2;
const string Event_Scene::GOSUB_STR = "割り込み";

Event_Scene::Event_Scene(int type, Scene* scene, int frameCount)
{
    this->type = type;
    this->scene = scene;
    this->frameCount = frameCount;
}

Event_Scene::Event_Scene(int type, Scene* scene)
{
    this->type = type;
    this->scene = scene;
}

void Event_Scene::doEvent(SceneMediator* mediator)
{
    switch ( type ) {
        case END:
        {
            mediator->endScene();
            break;
        }
        case GOTO:
        {
            mediator->gotoScene(scene);
            break;
        }
        case GOSUB:
        {
            mediator->gosubScene(scene);
            break;
        }
        default:
        {
            cerr << "無効なシーン遷移イベント(" << type << ")です。" << endl;
            exit(-1);
        }
    }
}
