/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __LABEL_H__INCLUDED__
#define __LABEL_H__INCLUDED__
#include "FlyingObject.h"
#include "Scene/ActionListener.h"

#include <SDL/SDL.h>

class Face;
class SceneMediator;
class Label : public FlyingObject, public ActionListener
{
private:
    int timerCount;
    int extraTimerCount;
    double x;
    double y;
    double dx;
    double dy;
    double dalpha;
    double alpha;
    void setEffect(int effect, int timer);
    Face* face;

public:
    static const int FADEIN = 1;
    static const int FADEOUT = 2;
    static const int TILE = 3;
    Label();
    ~Label();

    void init(SceneMediator* mediator);
    Label* clone();

    virtual bool action(SceneMediator* mediator);
    void destroy();
    void destroy(SceneMediator* mediator);

    static Label* createLabel(SDL_Surface* surface, double x, double y, double dx, double dy, int timer, int extTimer, int effect);

    static Label* createLabel(const char* text, double x, double y, double dx, double dy, int timer, int extTimer, int effect);
    static Label* createLabel(const char* text, SDL_Color* color, double x, double y, double dx, double dy, int timer, int extTimer, int effect);
};

#endif

