/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <stdio.h>
#include <iostream>

#include "common.h"
#include "ActionListener.h"
#include "ActionManager.h"
#include "List.h"
#include "SceneMediator.h"

using namespace std;

ActionManager::ActionManager(SceneMediator* mediator)
{
    this->mediator = mediator;
    actionNow = false;
    actionList = NULL;
}

void ActionManager::destroy()
{
    List<ActionListener>::Item* i = actionList->getBegin();
    while ( i != actionList->getEnd() ) {
        i->getObject()->destroy(mediator);
        i = i->getNext();
    }
    delete actionList;
    actionList = NULL;
}

void ActionManager::pause()
{
}

void ActionManager::unpause()
{
}

void ActionManager::standby()
{
    actionList = new List<ActionListener>(6000);
}

void ActionManager::manage()
{
    actionNow = true;

    List<ActionListener>::Item* f;
    for ( f = actionList->getBegin(); f != actionList->getEnd(); ) {

        ActionListener* listener = f->getObject();

        if ( listener->action(mediator) ) {
            f = f->getNext(); 

        } else {
            f = actionList->erase(listener->getListIndex());

        }

    }
 
    actionNow = false;
}

void ActionManager::removeAction(ActionListener* listener)
{
    if ( actionNow ) {
        cerr << "ActionManager::removeAction(): Action NOW." << endl;
        exit(-1);
    }

    actionList->erase(listener->getListIndex());
}

void ActionManager::addAction(ActionListener* listener)
{
    actionList->add(listener);
    listener->setListIndex(actionList->getEnd()->getPrevious());
}

int ActionManager::getActionSize()
{
    return actionList->getSize();
}
