/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>

#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>

#include "Sound.h"

using namespace std;

Sound* Sound::instance = NULL;
//Mix_Chunk* Sound::explosion = NULL;

Sound::Sound()
{
    //explosion = Mix_LoadWAV("explosion.wav");
}

Sound::~Sound()
{
}

Sound* Sound::getInstance()
{
    if ( Sound::instance == NULL ) { Sound::instance = new Sound(); }
    return Sound::instance;
}

void Sound::playSound(int channel, string file, int loop)
{
    if ( channel >= 3 ) { return; }
    Sound* sound = Sound::getInstance();
    Mix_PlayChannel(channel, sound->loadSound(file), loop);
}

Mix_Chunk* Sound::loadSound(string file)
{
    map<string, Mix_Chunk*>::iterator i = seMap.find(file);
    if ( i != seMap.end() ) { return (*i).second; }

    Mix_Chunk* chunk = Mix_LoadWAV(file.c_str());
    if ( chunk == NULL ) {
        cerr << "Mix_LoadWAV(\"" << file << "\"): " << Mix_GetError() << endl;
        exit(-1);
    }

    seMap[file] = chunk;

    return chunk;
}

void Sound::playMusic(string file, int loop)
{
    if ( Mix_PlayMusic(getInstance()->loadMusic(file), loop) == -1 ) {
        cerr << "Mix_PlayMusic(\"" << file << "\"): " << Mix_GetError();
        exit(-1);
    }
}

void Sound::playFadeinMusic(string file, int loop, int time)
{
    if ( Mix_FadeInMusic(getInstance()->loadMusic(file), loop, time) == -1 ) {
        cerr << "Mix_FadeInMusic(\"" << file << "\"): " << Mix_GetError();
        exit(-1);
    }
}

Mix_Music* Sound::loadMusic(string file)
{
    map<string, Mix_Music*>::iterator i = musicMap.find(file);
    if ( i != musicMap.end() ) { return (*i).second; }

    Mix_Music* music = Mix_LoadMUS(file.c_str());
    if ( music == NULL ) {
        cerr << "Mix_LoadMUS(\"" << file << "\"): " << Mix_GetError() << endl;
        exit(-1);
    }

    musicMap[file] = music;

    return music;
}

