/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <map>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include <SDL/SDL.h>

#include "../Event_AddFO.h"
#include "../Face.h"
#include "../KeyAction.h"
#include "../Library.h"
#include "../ActionFO.h"
#include "../ActionCommand.h"
#include "../ActionSequence.h"
#include "../Scene/CollisionGroup.h"

#include "ActionFOElement.h"
#include "ActionSequenceElement.h"
#include "KeyEntryElement.h"
#include "SceneEventElement.h"

ActionFOElement::ActionFOElement(char* super)
{
    name = "オブジェクト";
    superID = super;
    event = NULL;
    type = SCENEEVENT;
    object = NULL;
    
    image = NULL;
    frameWidth = NULL;
    frameHeight = NULL;
    frameIntarval = NULL;
    x = NULL;
    y = NULL;
    dx = NULL;
    dy = NULL;
    width = NULL;
    height = NULL;
    boundx1 = NULL;
    boundy1 = NULL;
    boundx2 = NULL;
    boundy2 = NULL;
    offsetX = NULL;
    offsetY = NULL;
    slowdownrate = NULL;
    life = NULL;
    objectType = NULL;
    actionSequence = NULL;
    reactionSequence = NULL;
    damagedCommand = NULL;
    destroyedCommand = NULL;
    powerUpCommand = NULL;
    impactResilience = NULL;
    damageAmount = NULL;
    keyEntry = NULL;
    layer = NULL;
}

Element* ActionFOElement::getChild(char* name, char* super)
{
    if ( strcmp("画像", name) == 0 ) {
        image = new Element("画像", super);
        return image;
    }
    else if ( strcmp("横表示位置", name) == 0 ) {
        offsetX = new Element("横表示位置", super);
        return offsetX;
    }
    else if ( strcmp("縦表示位置", name) == 0 ) {
        offsetY = new Element("縦表示位置", super);
        return offsetY;
    }
    else if ( strcmp("コマ幅", name) == 0 ) {
        frameWidth = new Element("コマ幅", super);
        return frameWidth;
    }
    else if ( strcmp("コマ高", name) == 0 ) {
        frameHeight = new Element("コマ高", super);
        return frameHeight;
    }
    else if ( strcmp("コマ間隔", name) == 0 ) {
        frameIntarval = new Element("コマ間隔", super);
        return frameIntarval;
    }
    else if ( strcmp("横位置", name) == 0 ) {
        x = new Element("横位置", super);
        return x;
    }
    else if ( strcmp("縦位置", name) == 0 ) {
        y = new Element("縦位置", super);
        return y;
    }
    else if ( strcmp("横初速度", name) == 0 ) {
        dx = new Element("横初速度", super);
        return dx;
    }
    else if ( strcmp("縦初速度", name) == 0 ) {
        dy = new Element("縦初速度", super);
        return dy;
    }
    else if ( strcmp("幅", name) == 0 ) {
        width = new Element("幅", super);
        return width;
    }
    else if ( strcmp("高さ", name) == 0 ) {
        height = new Element("高さ", super);
        return height;
    }
    else if ( strcmp("左境界", name) == 0 ) {
        boundx1 = new Element("左境界", super);
        return boundx1;
    }
    else if ( strcmp("上境界", name) == 0 ) {
        boundy1 = new Element("上境界", super);
        return boundy1;
    }
    else if ( strcmp("右境界", name) == 0 ) {
        boundx2 = new Element("右境界", super);
        return boundx2;
    }
    else if ( strcmp("下境界", name) == 0 ) {
        boundy2 = new Element("下境界", super);
        return boundy2;
    }
    else if ( strcmp("減衰率", name) == 0 ) {
        slowdownrate = new Element("減衰率", super);
        return slowdownrate;
    }
    else if ( strcmp("ライフ", name) == 0 ) {
        life = new Element("ライフ", super);
        return life;
    }
    else if ( strcmp("種類", name) == 0 ) {
        objectType = new Element("種類", super);
        return objectType;
    }
    else if ( strcmp("レイヤー", name) == 0 ) {
        layer = new Element("レイヤー", super);
        return layer;
    }
    else if ( strcmp("アクションシーケンス", name) == 0 ) {
        actionSequence = new ActionSequenceElement(super);
        return actionSequence;
    }
    else if ( strcmp("衝突リアクション", name) == 0 ) {
        reactionSequence = new ActionSequenceElement(super);
        return reactionSequence;
    }
    else if ( strcmp("被ダメージリアクション", name) == 0 ) {
        damagedCommand = new ActionSequenceElement(super);
        return damagedCommand;
    }
    else if ( strcmp("被破壊リアクション", name) == 0 ) {
        destroyedCommand = new ActionSequenceElement(super);
        return destroyedCommand;
    }
    else if ( strcmp("パワーアップリアクション", name) == 0 ) {
        powerUpCommand = new ActionSequenceElement(super);
        return powerUpCommand;
    }
    else if ( strcmp("ダメージ量", name) == 0 ) {
        damageAmount = new Element(super);
        return damageAmount;
    }
    else if ( strcmp("弾性", name) == 0 ) {
        impactResilience = new Element(super);
        return impactResilience;
    }
    else if ( strcmp("キー登録", name) == 0 ) {
        if ( this->keyEntry == NULL ) { this->keyEntry = new list<KeyEntryElement*>; }
        KeyEntryElement* kelm = new KeyEntryElement(super);
        keyEntry->push_back(kelm);
        return kelm;
    }
    else {
        invalidElement(name);
    }
}

void ActionFOElement::endElement()
{
}
    
ActionFO* ActionFOElement::getActionFO()
{
    if ( object != NULL ) { return object; }
    ActionFO* afo = ActionFO::create();
    this->object = afo;

    afo->x = getX(NULL);
    afo->y = getY(NULL);
    afo->width = getWidth(NULL);
    afo->height = getHeight(NULL);
    afo->setSpeed(getDX(NULL), getDY(NULL));
    afo->setBound(getBoundx1(NULL), getBoundy1(NULL), getBoundx2(NULL), getBoundy2(NULL));

    afo->setAction(getActionSequence(NULL));
    afo->setReaction(getReactionSequence(NULL));
    afo->setDamaged(getDamagedCommand(NULL));
    afo->setPowered(getPowerUpCommand(NULL));
    afo->setDestroyed(getDestroyedCommand(NULL));

    afo->setSurface(getImage(NULL), getFrameWidth(NULL), getFrameHeight(NULL), getFrameIntarval(NULL));
    afo->setGroup(getObjectType(NULL));
    afo->life = getLife(NULL);
    afo->setOffset(getOffsetX(NULL), getOffsetY(NULL));
    afo->setSlowdownRate(getSlowdownrate(NULL));
    afo->impactResilience = getImpactResilience(NULL);
    afo->setDamageAmount(getDamageAmount(NULL));
    afo->setLayer(getLayer(NULL));
    
    list<KeyEntryElement*>* keyEntry = getKeyEntry(NULL);
    if ( keyEntry == NULL ) { /* do nothing */ }
    else {
        list<KeyEntryElement*>::iterator i = keyEntry->begin();
        while ( i != keyEntry->end() ) {
            afo->addKeyAction( (*i)->getEntry() );
            i++;
        }
    }

    return afo;
}

SceneEvent* ActionFOElement::getEvent()
{
    if ( event != NULL ) { return event; }
    event = new Event_AddFO(getActionFO());
    return event;
}

SDL_Surface* ActionFOElement::getImage(list<string>* path)
{
    checkInheritanceNoDefault(getImage, image, ActionFOElement, "画像が設定されていません。");
    return Library::loadImage((dir / image->getValue(NULL)).string());
}

int ActionFOElement::getFrameHeight(list<string>* path)
{
    checkInheritance(getFrameHeight, frameHeight, ActionFOElement, getImage(NULL)->h);
    return atoi(frameHeight->getValue(NULL).c_str());
}

int ActionFOElement::getFrameWidth(list<string>* path)
{
    checkInheritance(getFrameWidth, frameWidth, ActionFOElement, getImage(NULL)->w);
    return atoi(frameWidth->getValue(NULL).c_str());
}

int ActionFOElement::getFrameIntarval(list<string>* path)
{
    checkInheritance(getFrameIntarval, frameIntarval, ActionFOElement, -1);
    return atoi(frameIntarval->getValue(NULL).c_str());
}

double ActionFOElement::getX(list<string>* path)
{
    checkInheritance(getX, x, ActionFOElement, 0);
    return atof(x->getValue(NULL).c_str());
}
double ActionFOElement::getY(list<string>* path)
{
    checkInheritance(getY, y, ActionFOElement, 0);
    return atof(y->getValue(NULL).c_str());
}
double ActionFOElement::getDX(list<string>* path)
{
    checkInheritance(getDX, dx, ActionFOElement, 0);
    return atof(dx->getValue(NULL).c_str());
}
double ActionFOElement::getDY(list<string>* path)
{
    checkInheritance(getDY, dy, ActionFOElement, 0);
    return atof(dy->getValue(NULL).c_str());
}
int ActionFOElement::getWidth(list<string>* path)
{
    checkInheritance(getWidth, width, ActionFOElement, 0);
    return atoi(width->getValue(NULL).c_str());
}
int ActionFOElement::getHeight(list<string>* path)
{
    checkInheritance(getHeight, height, ActionFOElement, 0);
    return atoi(height->getValue(NULL).c_str());
}
int ActionFOElement::getBoundx1(list<string>* path)
{
    checkInheritance(getBoundx1, boundx1, ActionFOElement, 0);
    return atoi(boundx1->getValue(NULL).c_str());
}
int ActionFOElement::getBoundy1(list<string>* path)
{
    checkInheritance(getBoundy1, boundy1, ActionFOElement, 0);
    return atoi(boundy1->getValue(NULL).c_str());
}
int ActionFOElement::getBoundx2(list<string>* path)
{
    checkInheritance(getBoundx2, boundx2, ActionFOElement, 0);
    return atoi(boundx2->getValue(NULL).c_str());
}
int ActionFOElement::getBoundy2(list<string>* path)
{
    checkInheritance(getBoundy2, boundy2, ActionFOElement, 0);
    return atoi(boundy2->getValue(NULL).c_str());
}
int ActionFOElement::getOffsetX(list<string>* path)
{
    checkInheritance(getOffsetX, offsetX, ActionFOElement, 0);
    return atoi(offsetX->getValue(NULL).c_str());
}
int ActionFOElement::getOffsetY(list<string>* path)
{
    checkInheritance(getOffsetY, offsetY, ActionFOElement, 0);
    return atoi(offsetY->getValue(NULL).c_str());
}
double ActionFOElement::getSlowdownrate(list<string>* path)
{
    checkInheritance(getSlowdownrate, slowdownrate, ActionFOElement, 1.2);
    return atof(slowdownrate->getValue(NULL).c_str());
}
double ActionFOElement::getImpactResilience(list<string>* path)
{
    checkInheritance(getImpactResilience, impactResilience, ActionFOElement, 1);
    return atof(impactResilience->getValue(NULL).c_str());
}
int ActionFOElement::getDamageAmount(list<string>* path)
{
    checkInheritance(getDamageAmount, damageAmount, ActionFOElement, 0);
    return atoi(damageAmount->getValue(NULL).c_str());
}
int ActionFOElement::getLife(list<string>* path)
{
    checkInheritance(getLife, life, ActionFOElement, 1);
    return atoi(life->getValue(NULL).c_str());
}

CollisionGroup::group ActionFOElement::getObjectType(list<string>* path)
{
    checkInheritance(getObjectType, objectType, ActionFOElement, CollisionGroup::ENEMY);
    CollisionGroup::group objectType = CollisionGroup::convertGroupString(this->objectType->getValue(NULL));
    if ( objectType == CollisionGroup::UNKNOWN ) {
        syntaxError("不明なオブジェクトの種類が選択されました。");
    }
    return objectType;
}

ActionCommand* ActionFOElement::getActionSequence(list<string>* path)
{
    checkInheritance(getActionSequence, actionSequence, ActionFOElement, ActionSequence::create());
    return actionSequence->getCommand(NULL);
}

ActionCommand* ActionFOElement::getReactionSequence(list<string>* path)
{
    checkInheritance(getReactionSequence, reactionSequence, ActionFOElement, ActionSequence::create());
    return reactionSequence->getCommand(NULL);
}
ActionCommand* ActionFOElement::getDamagedCommand(list<string>* path)
{
    checkInheritance(getDamagedCommand, damagedCommand, ActionFOElement, ActionSequence::create());
    return damagedCommand->getCommand(NULL);
}
ActionCommand* ActionFOElement::getDestroyedCommand(list<string>* path)
{
    checkInheritance(getDestroyedCommand, destroyedCommand, ActionFOElement, ActionSequence::create());
    return destroyedCommand->getCommand(NULL);
}
ActionCommand* ActionFOElement::getPowerUpCommand(list<string>* path)
{
    checkInheritance(getPowerUpCommand, powerUpCommand, ActionFOElement, ActionSequence::create());
    return powerUpCommand->getCommand(NULL);
}
list<KeyEntryElement*>* ActionFOElement::getKeyEntry(list<string>* path)
{
    //checkInheritance(getKeyEntry, keyEntry, ActionFOElement, new list<KeyEntryElement*>);
    checkInheritance(getKeyEntry, keyEntry, ActionFOElement, NULL);
    return keyEntry;
}

int ActionFOElement::getLayer(list<string>* path)
{
    checkInheritance(getLayer, layer, ActionFOElement, 2);
    return atoi(layer->getValue(NULL).c_str());
}
