/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __ACTIONFOELEMENT_H__INCLUDED__
#define __ACTIONFOELEMENT_H__INCLUDED__
#include "SceneEventElement.h"
#include "../Scene/CollisionGroup.h"

class ActionCommand;
class ActionFO;
class ActionSequenceElement;
class Element;
class KeyEntryElement;
class ActionFOElement : public SceneEventElement
{
private:
    Element* image;
    Element* frameWidth;
    Element* frameHeight;
    Element* frameIntarval;
    Element* x;
    Element* y;
    Element* dx;
    Element* dy;
    Element* width;
    Element* height;
    Element* boundx1;
    Element* boundy1;
    Element* boundx2;
    Element* boundy2;
    Element* offsetX;
    Element* offsetY;
    Element* slowdownrate;
    Element* life;
    Element* objectType;
    Element* impactResilience;
    Element* damageAmount;
    Element* layer;

    ActionSequenceElement* actionSequence;
    ActionSequenceElement* reactionSequence;
    ActionSequenceElement* damagedCommand;
    ActionSequenceElement* destroyedCommand;
    ActionSequenceElement* powerUpCommand;

    list<KeyEntryElement*>* keyEntry;
    ActionFO* object;
public:
    ActionFOElement(char* super);
    virtual Element* getChild(char* name, char* super);
    virtual void endElement();

    SDL_Surface* getImage(std::list<std::string>* path);
    int getFrameHeight(std::list<std::string>* path);
    int getFrameWidth(std::list<std::string>* path);
    int getFrameIntarval(std::list<std::string>* path);
    double getX(std::list<std::string>* path);
    double getY(std::list<std::string>* path);
    double getDX(std::list<std::string>* path);
    double getDY(std::list<std::string>* path);
    int getWidth(std::list<std::string>* path);
    int getHeight(std::list<std::string>* path);
    int getBoundx1(std::list<std::string>* path);
    int getBoundy1(std::list<std::string>* path);
    int getBoundx2(std::list<std::string>* path);
    int getBoundy2(std::list<std::string>* path);
    int getOffsetX(std::list<std::string>* path);
    int getOffsetY(std::list<std::string>* path);
    double getSlowdownrate(std::list<std::string>* path);
    double getImpactResilience(std::list<std::string>* path);
    int getDamageAmount(std::list<std::string>* path);
    int getLife(std::list<std::string>* path);
    int getLayer(std::list<std::string>* path);
    CollisionGroup::group getObjectType(std::list<std::string>* path);
    ActionCommand* getActionSequence(std::list<std::string>* path);
    ActionCommand* getReactionSequence(std::list<std::string>* path);
    ActionCommand* getDamagedCommand(std::list<std::string>* path);
    ActionCommand* getDestroyedCommand(std::list<std::string>* path);
    ActionCommand* getPowerUpCommand(std::list<std::string>* path);
    list<KeyEntryElement*>* getKeyEntry(std::list<std::string>* path);
    ActionFO* getActionFO();
    SceneEvent* getEvent();
};
#endif

