/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include "../ActionCommand.h"
#include "../ActionHoming.h"
#include "../Scene/CollisionGroup.h"

#include "ActionHomingElement.h"

ActionHomingElement::ActionHomingElement(char* super)
{
    name = "追尾";
    superID = super;
    
    speed = NULL;
    index = NULL;
    target = NULL;
    frameCount = NULL;
    dx = NULL;
    dy = NULL;
    coefficientHomingX = NULL;
    coefficientHomingY = NULL;

    command = NULL;
}

Element* ActionHomingElement::getChild(char* name, char* super)
{
    if ( strcmp("速度", name) == 0 ) {
        speed = new Element("速度", super);
        return speed;
    }
    else if ( strcmp("番号", name) == 0 ) {
        index = new Element("番号", super);
        return index;
    }
    else if ( strcmp("種類", name) == 0 ) {
        target = new Element("種類", super);
        return target;
    }
    else if ( strcmp("時間", name) == 0 ) {
        frameCount = new Element("時間", super);
        return frameCount;
    }
    else if ( strcmp("横速度", name) == 0 ) {
        dx = new Element("横速度", super);
        return dx;
    }
    else if ( strcmp("縦速度", name) == 0 ) {
        dy = new Element("縦速度", super);
        return dy;
    }
    else if ( strcmp("横速度補正", name) == 0 ) {
        coefficientHomingX = new Element("横速度補正", super);
        return coefficientHomingX;
    }
    else if ( strcmp("縦速度補正", name) == 0 ) {
        coefficientHomingY = new Element("縦速度補正", super);
        return coefficientHomingY;
    }
    else {
        invalidElement(name);
    }
}

void ActionHomingElement::endElement()
{
}


int ActionHomingElement::getIndex(list<string>* path)
{
    checkInheritance(getIndex, index, ActionHomingElement, 0);
    return atoi(index->getValue(NULL).c_str());
}
double ActionHomingElement::getSpeed(list<string>* path)
{
    checkInheritance(getSpeed, speed, ActionHomingElement, 1);
    return atof(speed->getValue(NULL).c_str());
}
int ActionHomingElement::getFrameCount(list<string>* path)
{
    checkInheritance(getFrameCount, frameCount, ActionHomingElement, 1);
    return atoi(frameCount->getValue(NULL).c_str());
}

CollisionGroup::group ActionHomingElement::getTarget(list<string>* path)
{
    checkInheritance(getTarget, target, ActionHomingElement, CollisionGroup::PLAYER);
    CollisionGroup::group t = CollisionGroup::convertGroupString(target->getValue(NULL));
    if ( t == CollisionGroup::UNKNOWN ) {
        syntaxError("追尾には不明な種類("+target->getValue(NULL)+")です。");
    }
    return t;
}
double ActionHomingElement::getDX(list<string>* path)
{
    checkInheritance(getDX, dx, ActionHomingElement, 0);
    return atof(dx->getValue(NULL).c_str());
}
double ActionHomingElement::getDY(list<string>* path)
{
    checkInheritance(getDY, dy, ActionHomingElement, 0);
    return atof(dy->getValue(NULL).c_str());
}
double ActionHomingElement::getCoefficentHomingX(list<string>* path)
{
    checkInheritance(getCoefficentHomingX, coefficientHomingX, ActionHomingElement, 1);
    return atof(coefficientHomingX->getValue(NULL).c_str());
}
double ActionHomingElement::getCoefficentHomingY(list<string>* path)
{
    checkInheritance(getCoefficentHomingY, coefficientHomingY, ActionHomingElement, 1);
    return atof(coefficientHomingY->getValue(NULL).c_str());
}

ActionCommand* ActionHomingElement::getCommand(list<string>* path)
{
    if ( command != NULL ) { return command; }
    command = ActionHoming::create(getTarget(NULL), getIndex(NULL), getSpeed(NULL), getFrameCount(NULL), getDX(NULL), getDY(NULL), getCoefficentHomingX(NULL), getCoefficentHomingY(NULL));
    return command;
}
