/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include "../ActionCommand.h"
#include "../ActionMove.h"

#include "ActionMoveElement.h"

ActionMoveElement::ActionMoveElement(char* super)
{
    name = "移動";
    superID = super;
    
    dx = NULL;
    dy = NULL;
    frameCount = NULL;
    command = NULL;
}

Element* ActionMoveElement::getChild(char* name, char* super)
{
    if ( strcmp("横推進力", name) == 0 ) {
        dx = new Element("横推進力", super);
        return dx;
    }
    else if ( strcmp("縦推進力", name) == 0 ) {
        dy = new Element("縦推進力", super);
        return dy;
    }
    else if ( strcmp("時間", name) == 0 ) {
        frameCount = new Element("時間", super);
        return frameCount;
    }
    else {
        invalidElement(name);
    }
}

void ActionMoveElement::endElement()
{
}

double ActionMoveElement::getDX(list<string>* path)
{
    checkInheritance(getDX, dx, ActionMoveElement, 0);
    return atof(dx->getValue(NULL).c_str());
}
double ActionMoveElement::getDY(list<string>* path)
{
    checkInheritance(getDY, dy, ActionMoveElement, 0);
    return atof(dy->getValue(NULL).c_str());
}
int ActionMoveElement::getFrameCount(list<string>* path)
{
    checkInheritance(getFrameCount, frameCount, ActionMoveElement, 0);
    return atoi(frameCount->getValue(NULL).c_str());
}

ActionCommand* ActionMoveElement::getCommand(list<string>* path)
{
    if ( command != NULL ) { return command; }
    command = ActionMove::create(getDX(NULL), getDY(NULL), getFrameCount(NULL));
    return command;
}
