/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include "../ActionCommand.h"
#include "../ActionMoveTarget.h"

#include "ActionMoveTargetElement.h"

ActionMoveTargetElement::ActionMoveTargetElement(char* super)
{
    name = "場所移動";
    superID = super;
    
    x = NULL;
    y = NULL;
    speed = NULL;
    frameCount = NULL;
    command = NULL;
}

Element* ActionMoveTargetElement::getChild(char* name, char* super)
{
    if ( strcmp("速度", name) == 0 ) {
        speed = new Element("速度", super);
        return speed;
    }
    else if ( strcmp("横位置", name) == 0 ) {
        x = new Element("横位置", super);
        return x;
    }
    else if ( strcmp("縦位置", name) == 0 ) {
        y = new Element("縦位置", super);
        return y;
    }
    else if ( strcmp("時間", name) == 0 ) {
        frameCount = new Element("時間", super);
        return frameCount;
    }
    else {
        invalidElement(name);
    }
}

void ActionMoveTargetElement::endElement()
{
}

double ActionMoveTargetElement::getX(list<string>* path)
{
    checkInheritance(getX, x, ActionMoveTargetElement, 0);
    return atof(x->getValue(NULL).c_str());
}
double ActionMoveTargetElement::getY(list<string>* path)
{
    checkInheritance(getY, y, ActionMoveTargetElement, 0);
    return atof(y->getValue(NULL).c_str());
}
double ActionMoveTargetElement::getSpeed(list<string>* path)
{
    checkInheritance(getSpeed, speed, ActionMoveTargetElement, 1);
    return atof(speed->getValue(NULL).c_str());
}
int ActionMoveTargetElement::getFrameCount(list<string>* path)
{
    checkInheritance(getFrameCount, frameCount, ActionMoveTargetElement, 0);
    return atoi(frameCount->getValue(NULL).c_str());
}

ActionCommand* ActionMoveTargetElement::getCommand(list<string>* path)
{
    if ( command != NULL ) { return command; }
    command = ActionMoveTarget::create(getX(NULL), getY(NULL), getSpeed(NULL), getFrameCount(NULL));
    return command;
}
