/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
#include <typeinfo>
#include <limits.h>
using namespace std;

#include <SDL/SDL.h>

#include "../Event_AddFO.h"
#include "../BGScroll.h"

#include "BGScrollElement.h"
#include "NoElement.h"
#include "SceneElement.h"
#include "SceneEventElement.h"
#include "WindowElement.h"

BGScrollElement::BGScrollElement(char* super)
{
    name = "背景";
    superID = super;
    event = NULL;
    type = SCENEEVENT;
    
    image = NULL;
    dx = NULL;
    dy = NULL;
    time = NULL;
}

Element* BGScrollElement::getChild(char* name, char* super)
{
    if ( strcmp("画像", name) == 0 ) {
        image = new Element("画像", super);
        return image;
    }
    else if ( strcmp("横速度", name) == 0 ) {
        dx = new Element("横速度", super);
        return dx;
    }
    else if ( strcmp("縦速度", name) == 0 ) {
        dy = new Element("縦速度", super);
        return dy;
    }
    else if ( strcmp("時間", name) == 0 ) {
        time = new Element("時間", super);
        return time;
    }
    else {
        invalidElement(name);
    }
}

void BGScrollElement::endElement()
{
}

string BGScrollElement::getImage(list<string>* path)
{
    checkInheritanceNoDefault(getImage, image, BGScrollElement, "画像が設定されていません。");
    return (dir / image->getValue(NULL).c_str()).native_file_string();
}
double BGScrollElement::getDX(list<string>* path)
{
    checkInheritance(getDX, dx, BGScrollElement, 0);
    return atof(dx->getValue(NULL).c_str());
}
double BGScrollElement::getDY(list<string>* path)
{
    checkInheritance(getDY, dy, BGScrollElement, 0);
    return atof(dy->getValue(NULL).c_str());
}
int BGScrollElement::getTime(list<string>* path)
{
    checkInheritance(getTime, time, BGScrollElement, INT_MAX);
    return atoi(time->getValue(NULL).c_str());
}

SceneEvent* BGScrollElement::getEvent()
{
    if ( event == NULL ) {
        event = new Event_AddFO( BGScroll::create(getImage(NULL).c_str(), getDX(NULL), getDY(NULL), getTime(NULL)) );
    }
    return event;
}

