/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
using namespace std;

#include "../Border.h"
#include "../Event_AddFO.h"
#include "../Scene/CollisionGroup.h"
#include "BorderElement.h"

BorderElement::BorderElement(char* super)
{
    name = "境界線";
    superID = super;
    event = NULL;
    type = SCENEEVENT;
    
    x = NULL;
    y = NULL;
    width = NULL;
    height = NULL;
    frameCount = NULL;
    group = NULL;
    impactResilience = NULL;
}

Element* BorderElement::getChild(char* name, char* super)
{
    if ( strcmp("横位置", name) == 0 ) {
        x = new Element("横位置", super);
        return x;
    }
    else if ( strcmp("縦位置", name) == 0 ) {
        y = new Element("縦位置", super);
        return y;
    }
    else if ( strcmp("幅", name) == 0 ) {
        width = new Element("幅", super);
        return width;
    }
    else if ( strcmp("高さ", name) == 0 ) {
        height = new Element("高さ", super);
        return height;
    }
    else if ( strcmp("フレーム数", name) == 0 ) {
        frameCount = new Element("フレーム数", super);
        return frameCount;
    }
    else if ( strcmp("種類", name) == 0 ) {
        group = new Element("種類", super);
        return group;
    }
    else if ( strcmp("弾性", name) == 0 ) {
        impactResilience = new Element("弾性", super);
        return impactResilience;
    }
    else {
        invalidElement(name);
    }
}

void BorderElement::endElement()
{
}


double BorderElement::getX(list<string>* path)
{
    checkInheritance(getX, x, BorderElement, 0);
    return atof(x->getValue(NULL).c_str());
}
double BorderElement::getY(list<string>* path)
{
    checkInheritance(getY, y, BorderElement, 0);
    return atof(y->getValue(NULL).c_str());
}
int BorderElement::getWidth(list<string>* path)
{
    checkInheritance(getWidth, width, BorderElement, 0);
    return atoi(width->getValue(NULL).c_str());
}
int BorderElement::getHeight(list<string>* path)
{
    checkInheritance(getHeight, height, BorderElement, 0);
    return atoi(height->getValue(NULL).c_str());
}
int BorderElement::getFrameCount(list<string>* path)
{
    checkInheritance(getFrameCount, frameCount, BorderElement, INT_MAX);
    return atoi(frameCount->getValue(NULL).c_str());
}
CollisionGroup::group BorderElement::getGroup(list<string>* path)
{
    checkInheritance(getGroup, group, BorderElement, CollisionGroup::PLAYER_GROUND);
    CollisionGroup::group group = CollisionGroup::convertGroupString(this->group->getValue(NULL));
    if ( group == CollisionGroup::UNKNOWN ) {
        syntaxError("不明なオブジェクトの種類が選択されました。");
    }
    return group;
}
double BorderElement::getImpactResilience(list<string>* path)
{
    checkInheritance(getImpactResilience, impactResilience, BorderElement, 1);
    return atof(impactResilience->getValue(NULL).c_str());
}

SceneEvent* BorderElement::getEvent()
{
    if ( event == NULL ) {
        event = new Event_AddFO(
            Border::create(
                getX(NULL),
                getY(NULL),
                getWidth(NULL),
                getHeight(NULL),
                getFrameCount(NULL),
                getGroup(NULL),
                getImpactResilience(NULL)
            )
        );
    }
    return event;
}

