/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include <SDL/SDL.h>

#include "ColorElement.h"

ColorElement::ColorElement(char* super)
{
    name = "色";
    superID = super;

    red = NULL;
    green = NULL;
    blue = NULL;
    color = NULL;
}

Element* ColorElement::getChild(char* name, char* super)
{
    if ( strcmp("赤", name) == 0 ) {
        red = new Element("赤", super);
        return red;
    }
    else if ( strcmp("緑", name) == 0 ) {
        green = new Element("緑", super);
        return green;
    }
    else if ( strcmp("青", name) == 0 ) {
        blue = new Element("青", super);
        return blue;
    }
    else {
        invalidElement(name);
    }
}

void ColorElement::endElement()
{
}

Uint8 ColorElement::getRed(list<string>* path)
{
    checkInheritance(getRed, red, ColorElement, 0);
    int c = atoi(red->getValue(NULL).c_str());
    if ( c < 0 || c > 255 ) {
        syntaxError("色の値は0から255の間でなければいけません。");
    }
    return c;
}

Uint8 ColorElement::getGreen(list<string>* path)
{
    checkInheritance(getGreen, green, ColorElement, 0);
    int c = atoi(green->getValue(NULL).c_str());
    if ( c < 0 || c > 255 ) {
        syntaxError("色の値は0から255の間でなければいけません。");
    }
    return c;
}

Uint8 ColorElement::getBlue(list<string>* path)
{
    checkInheritance(getBlue, blue, ColorElement, 0);
    int c = atoi(blue->getValue(NULL).c_str());
    if ( c < 0 || c > 255 ) {
        syntaxError("色の値は0から255の間でなければいけません。");
    }
    return c;
}


SDL_Color* ColorElement::getColor(list<string>* path)
{
    if ( color == NULL ) {
        color = new SDL_Color();
        color->r = getRed(NULL);
        color->g = getGreen(NULL);
        color->b = getBlue(NULL);
    }
    return color;
}

