/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include <SDL/SDL.h>

#include "../ActionSequence.h"
#include "../KeyEntry.h"
#include "../Library.h"

#include "ActionSequenceElement.h"
#include "KeyEntryElement.h"

KeyEntryElement::KeyEntryElement(char* super)
{
    name = "キー登録";
    superID = super;
    keySym = NULL;
    pressed = NULL;
    released = NULL;
    keyName = NULL;
    entry = NULL;
}

Element* KeyEntryElement::getChild(char* name, char* super)
{
    if ( strcmp("名前", name) == 0 ) {
        keyName = new Element("名前", super);
        return keyName;
    }
    else if ( strcmp("押したとき", name) == 0 ) {
        pressed = new ActionSequenceElement(super);
        return pressed;
    }
    else if ( strcmp("離したとき", name) == 0 ) {
        released = new ActionSequenceElement(super);
        return released;
    }
    else if ( strcmp("キー", name) == 0 ) {
        keySym = new Element("キー", super);
        return keySym;
    }
    else {
        invalidElement(name);
    }
}

void KeyEntryElement::endElement()
{
}

SDLKey KeyEntryElement::getKeySym(list<string>* path)
{
    checkInheritance(getKeySym, keySym, KeyEntryElement, SDLK_UNKNOWN);
    return Library::getKeySym(keySym->getValue(NULL));
}

string KeyEntryElement::getKeyName(list<string>* path)
{
    checkInheritanceNoDefault(getKeyName, keyName, KeyEntryElement, "名前が指定されていません。");
    return keyName->getValue(NULL);
}

ActionCommand* KeyEntryElement::getPressed(list<string>* path)
{
    checkInheritance(getPressed, pressed, KeyEntryElement, ActionSequence::create());
    return pressed->getCommand(NULL);
}
ActionCommand* KeyEntryElement::getReleased(list<string>* path)
{
    checkInheritance(getReleased, released, KeyEntryElement, ActionSequence::create());
    return released->getCommand(NULL);
}

KeyEntry* KeyEntryElement::getEntry()
{
    if ( entry == NULL ) {
        entry = new KeyEntry();
        entry->keyName = getKeyName(NULL);
        entry->keySym = getKeySym(NULL);
        entry->commandPressed = getPressed(NULL);
        entry->commandReleased = getReleased(NULL);
    }
    return entry;
}


