/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
using namespace std;

#include <SDL/SDL.h>

#include "MusicElement.h"
#include "../Event_Music.h"

MusicElement::MusicElement(char* super)
{
    name = "音楽";
    superID = super;
    event = NULL;
    type = SCENEEVENT;
    fileName = NULL;
    loop = NULL;
    startType = NULL;
    time = NULL;
}

Element* MusicElement::getChild(char* name, char* super)
{
    if ( strcmp("ファイル", name) == 0 ) {
        fileName = new Element("ファイル", super);
        return fileName;
    }
    else if ( strcmp("ループ", name) == 0 ) {
        loop = new Element("ループ", super);
        return loop;
    }
    else if ( strcmp("種類", name) == 0 ) {
        startType = new Element("種類", super);
        return startType;
    }
    else if ( strcmp("時間", name) == 0 ) {
        time = new Element("時間", super);
        return time;
    }
    else {
        invalidElement(name);
    }
}

void MusicElement::endElement()
{
}



string MusicElement::getFileName(list<string>* path)
{
    checkInheritance(getFileName, fileName, MusicElement, "");
    return (dir / fileName->getValue(NULL)).string();
}

int MusicElement::getLoop(list<string>* path)
{
    checkInheritance(getLoop, loop, MusicElement, 0);
    return atoi(loop->getValue(NULL).c_str());
}

int MusicElement::getStartType(list<string>* path)
{
    checkInheritance(getStartType, startType, MusicElement, Event_Music::START);
    if ( startType->getValue(NULL) == Event_Music::START_STR ) {
        return Event_Music::START;
    }
    else if ( startType->getValue(NULL) == Event_Music::FADEIN_STR ) {
        return Event_Music::FADEIN;
    }
    else if ( startType->getValue(NULL) == Event_Music::UNPAUSE_STR ) {
        return Event_Music::UNPAUSE;
    }
    else {
        syntaxError("<種類>に無効な値が選択されました。("+startType->getValue(NULL)+").");
    }
}

int MusicElement::getTime(list<string>* path)
{
    checkInheritance(getTime, time, MusicElement, 5000);
    return atoi(time->getValue(NULL).c_str());
}

SceneEvent* MusicElement::getEvent()
{
    if ( event == NULL ) {
        if ( getFileName(NULL) == "" &&
            getStartType(NULL) != Event_Music::UNPAUSE
        ) {
            syntaxError("ファイル名が指定されていません。");
        }
        event = new Event_Music( getFileName(NULL), getLoop(NULL), getStartType(NULL), getTime(NULL));
    }
    return event;
}

