/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string.h>
#include <stdlib.h>
using namespace std;

#include <SDL/SDL.h>

#include "MusicStopElement.h"
#include "../Event_MusicStop.h"

MusicStopElement::MusicStopElement(char* super)
{
    name = "音楽停止";
    superID = super;
    event = NULL;
    type = SCENEEVENT;

    stopType = NULL;
    time = NULL;
}

Element* MusicStopElement::getChild(char* name, char* super)
{
    if ( strcmp("種類", name) == 0 ) {
        stopType = new Element("種類", super);
        return stopType;
    }
    if ( strcmp("時間", name) == 0 ) {
        time = new Element("時間", super);
        return time;
    }
    else {
        invalidElement(name);
    }
}

void MusicStopElement::endElement()
{
}

int MusicStopElement::getStopType(list<string>* path)
{
    checkInheritance(getStopType, stopType, MusicStopElement, Event_MusicStop::STOP);
    if ( stopType->getValue(NULL) == Event_MusicStop::STOP_STR ) {
        return Event_MusicStop::STOP;
    }
    else if ( stopType->getValue(NULL) == Event_MusicStop::PAUSE_STR ) {
        return Event_MusicStop::PAUSE;
    }
    else if ( stopType->getValue(NULL) == Event_MusicStop::FADEOUT_STR ) {
        return Event_MusicStop::FADEOUT;
    }
    else {
        syntaxError("<種類>に無効な値が選択されました。("+stopType->getValue(NULL)+").");
    }
}
int MusicStopElement::getTime(list<string>* path)
{
    checkInheritance(getTime, time, MusicStopElement, 5000);
    return atoi(time->getValue(NULL).c_str());
}
SceneEvent* MusicStopElement::getEvent()
{
    if ( event == NULL ) {
        event = new Event_MusicStop(getStopType(NULL), getTime(NULL));
    }
    return event;
}

