/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __SAXHANDLER_H__INCLUDED__
#define __SAXHANDLER_H__INCLUDED__
#include <xercesc/sax2/DefaultHandler.hpp>
#include <xercesc/sax/Locator.hpp>
#include <xercesc/util/TransService.hpp>
#include <boost/filesystem/path.hpp>

#include <list>
#include <map>

using namespace std;
XERCES_CPP_NAMESPACE_USE

#include "Element.h"

class SAXHandler : public DefaultHandler
{
private:
    boost::filesystem::path dir;
    boost::filesystem::path xmlfile;
    XMLTranscoder* transcoder;
    XMLCh* transcode(const char* s);
    char* transcode(const XMLCh* s);
    char* getValue(const Attributes& attrs, char* name);
public:
    SAXHandler();
    list<Element*> contextStack;
    map<string, Element> elementMap;

    //void startDocument();

    void setDocumentLocator(const Locator* const locator);
    const Locator* locator;

    void startElement(
        const XMLCh* const uri,
        const XMLCh* const localname,
        const XMLCh* const qname,
        const Attributes& attrs
    );
    void endElement(
        const XMLCh* const uri,
        const XMLCh* const localname,
        const XMLCh* const qname
    );
    void characters( const XMLCh* const chars, const unsigned int length);
    void fatalError(const SAXParseException&);
    void setDir(boost::filesystem::path dir);
    void setXMLFile(boost::filesystem::path xmlfile);
};
#endif

