/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include "../Event_Scene.h"

#include "SceneTransitionElement.h"
#include "SceneElement.h"
#include "SceneEventElement.h"

SceneTransitionElement::SceneTransitionElement(char* super)
{
    name = "場面遷移";
    superID = super;
    event = NULL;
    type = SCENEEVENT;

    transitionType = NULL;
    nextScene = NULL;
}

Element* SceneTransitionElement::getChild(char* name, char* super)
{
    if ( strcmp("場面名", name) == 0 ) {
        nextScene = new Element("場面名", super);
        return nextScene;
    }
    else if ( strcmp("種類", name) == 0 ) {
        transitionType = new Element("種類", super);
        return transitionType;
    }
    else {
        invalidElement(name);
    }
}

void SceneTransitionElement::endElement()
{
}



Scene* SceneTransitionElement::getNextScene(list<string>* path)
{
    checkInheritanceNoDefault(getNextScene, nextScene, SceneTransitionElement, "遷移先の場面名が指定されていません");
    string nextScene = this->nextScene->getValue(NULL);
    if ( namedElements.find(nextScene) == namedElements.end() ) {
        syntaxError("指定された場面("+nextScene+")は存在しません");
    }
    if ( typeid(*namedElements[nextScene]) != typeid(SceneElement) ) {
        syntaxError("指定した名前("+nextScene+")は場面ではありません。");
    }
    return ((SceneElement*)Element::namedElements[nextScene])->getScene(NULL);
}


int SceneTransitionElement::getTransitionType(list<string>* path)
{
    checkInheritance(
        getTransitionType,
        transitionType,
        SceneTransitionElement,
        Event_Scene::END
    );

    string typeName = transitionType->getValue(NULL);

    if ( typeName == Event_Scene::END_STR ) {
        return Event_Scene::END;
    }
    else if ( typeName == Event_Scene::GOTO_STR ) {
        return Event_Scene::GOTO;
    }
    else if ( typeName == Event_Scene::GOSUB_STR ) {
        return Event_Scene::GOSUB;
    }
}

SceneEvent* SceneTransitionElement::getEvent()
{
    if ( event == NULL ) {
        int type = getTransitionType(NULL);
        if ( type == Event_Scene::END ) {
            event = new Event_Scene(type, NULL);
        }
        else {
            event = new Event_Scene(type, getNextScene(NULL));
        }
    }
    return event;
}

