/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <string>
#include <stdlib.h>
#include <string.h>
using namespace std;

#include <SDL/SDL.h>

#include "SoundElement.h"
#include "../Event_Sound.h"

SoundElement::SoundElement(char* super)
{
        name = "効果音";
        superID = super;
        event = NULL;
        type = SCENEEVENT;
        fileName = NULL;
        loop = NULL;
        channel = NULL;
}

Element* SoundElement::getChild(char* name, char* super)
{
    if ( strcmp("ファイル", name) == 0 ) {
        fileName = new Element("ファイル", super);
        return fileName;
    }
    else if ( strcmp("ループ", name) == 0 ) {
        loop = new Element("ループ", super);
        return loop;
    }
    else if ( strcmp("チャンネル", name) == 0 ) {
        channel = new Element("チャンネル", super);
        return channel;
    }
    else {
        invalidElement(name);
    }
}

void SoundElement::endElement()
{
}

string SoundElement::getFileName(list<string>* path)
{
    checkInheritanceNoDefault(getFileName, fileName, SoundElement, "サウンドファイルが指定されていません。");
    return (dir / fileName->getValue(NULL)).string();
}
int SoundElement::getLoop(list<string>* path)
{
    checkInheritance(getLoop, loop, SoundElement, 0);
    return atoi(loop->getValue(NULL).c_str());
}
int SoundElement::getChannel(list<string>* path)
{
    checkInheritance(getChannel, channel, SoundElement, 0);
    int c = atoi(channel->getValue(NULL).c_str());
    if ( c >= 3 ) {
        syntaxError("チャンネル番号は０から２までの間しか指定できません。");
    }
    return c;
}

SceneEvent* SoundElement::getEvent()
{
    if ( event == NULL ) {
        event = new Event_Sound(
            getChannel(NULL), 
            getFileName(NULL),
            getLoop(NULL)
        );
    }
    return event;
}

