/*

ダイコン： STGスクリプトインタープリタは日本語XMLタグによるシューティングゲームのエンジンです。
Copyright (C) 2009 karasimiso

このプログラムはフリーソフトウェアです。あなたはこれを、フリーソフトウェア財団によって発行されたGNU 一般公衆利用許諾書(バージョン3か、 それ以降のバージョンのうちどれか)が定める条件の下で再頒布または改変することができます。

このプログラムは有用であることを願って頒布されますが、*全くの無保証 *です。商業可能性の保証や特定目的への適合性は、言外に示されたものも 含め、全く存在しません。詳しくはGNU 一般公衆利用許諾書をご覧ください。

あなたはこのプログラムと共に、GNU 一般公衆利用許諾書のコピーを一部受け取っているはずです。もし受け取っていなければ、<http://www.gnu.org/licenses/> をご覧ください。



Daikon: STG Script Interpreter is game engine for shooting game in Japanese XML tags.
Copyright (C) 2009 karasimiso

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __COMMON_H__INCLUDED__
#define __COMMON_H__INCLUDED__
#include <list>
#include "List.h"
#include "SDL/SDL.h"
using namespace std;

namespace common
{
    // STLライブラリのlistコンテナに登録されたオブジェクトをdeleteする
    // list<Hogehoge*> のような変数に使用する
    template<class TYPE>
    inline void freeList(list<TYPE>& l)
    {
        typename list<TYPE>::iterator i = l.begin();
        while ( 1 ) {
            if ( i == l.end() ) break;
                if ( (*i) != NULL ) delete *i;
                i = l.erase(i);
        }
    }

    SDL_Surface* createString(const char* text);
    SDL_Surface* createHugeString(const char* text);

    template<class TYPE>
    inline void freeList(List<TYPE>& l)
    {
        typename List<TYPE>::Item* i = l.getBegin();
        while ( 1 ) {
            if ( i == l.getEnd() ) break;
                if ( i->getObject() != NULL ) delete i->getObject();
                i = l.erase(i);
        }
    }

};

#endif

